# Oktaplus

Oktaplus provides Okta-specific enhancements for the
[OpenID Connect](https://www.drupal.org/project/openid_connect) module.

## Configuration

Configuration can be found at `/admin/config/people/oktaplus`.

## Event hooks

Oktaplus provides an endpoint for
[Okta event hooks](https://developer.okta.com/docs/concepts/event-hooks/).

The endpoint controller handles GET requests to fulfill a
[One-time verification request](https://developer.okta.com/docs/concepts/event-hooks/#one-time-verification-request).

POST requests to the endpoint must use
[Basic authentication](https://developer.okta.com/docs/concepts/event-hooks/#http-headers)
with the configured event hook secret.

Events are added to the `oktaplus_event_queue` queue and should be processed
with a cron job:

```shell
0 * * * * drush queue:run oktaplus_event_queue
```

The following events can be configured to create and/or activate user accounts:

 * application.user_membership.add

The following events will result in Drupal user accounts being blocked:

 * application.user_membership.remove
 * user.lifecycle.deactivate
 * user.lifecycle.suspend

Furthermore, the following event will also delete the user from the authmap:

 * user.lifecycle.delete.initiated

If OpenID Connect is configured to use role mappings, the following events can
add or remove roles from existing users:

 * group.user_membership.add
 * group.user_membership.remove
